// just use hive for now

import 'dart:convert';
import 'dart:math';
import 'dart:typed_data';

class interzoneDisk {
  //HiveInterface db = Hive;
  final dynamic db;

  //Ipfs _ipfs;
  bool ready = false;
  bool _ghostMode = false;
  dynamic _foCapBox;
  dynamic _kaCapBox;
  dynamic _xxBox;
  dynamic _prefsCapBox;
  dynamic _mutesCapBox;
  dynamic _deletesCapBox;
  interzoneDisk(this.db);

  Future<bool> init(String path, bool ghostMode) async {
    //await db.initFlutter(); //init db elsewhere

    _ghostMode = ghostMode;

    _foCapBox = await db.openBox('focalCapsule' + path);
    _xxBox = await db.openBox('xxCache' + path);
    _kaCapBox = await db.openBox('katamari' + path);
    _prefsCapBox = await db.openBox('prefs' + path);
    _mutesCapBox = await db.openBox('prefsmutes' + path);
    _deletesCapBox = await db.openBox('prefsdelete' + path);

    ready = true;
    return true;
  }

  Future<Uint8List> get readKatamari async {
    Uint8List? u = await _kaCapBox.get('katamari');
    //_ubox.close();

    if (u == null) {
      return Uint8List(0);
    }
    print('[DB] read DONE');
    return u;
  }

  Future<bool> commitKatamari(Uint8List capsule) async {
    //conv into binary
    //if (db == null) return false;
    _kaCapBox.put('katamari', capsule);
    print('[DB] commit DONE');
    //_ubox.close();
    return true;
    //print(u.binary.sublist(64, 132));
  }

  Future<Uint8List?> get readCapsule async {
    Uint8List? u = await _foCapBox.get('capsule');
    //_ubox.close();

    if (u == null) {
      return null;
    }
    print('[DB] read DONE');
    return u;
  }

  Future<bool> commitCapsule(Uint8List capsule) async {
    //conv into binary
    //if (db == null) return false;
    _foCapBox.put('capsule', capsule);
    print('[DB] commit DONE');
    //_ubox.close();
    return true;
    //print(u.binary.sublist(64, 132));
  }

  Uint8List Uint64binaryList(List<int> d) {
    if (d.isEmpty) return Uint8List(0);
    int w = 0;
    Uint8List _l = Uint8List(128000);
    var b0 = new ByteData.view(_l.buffer);
    for (var id in d) {
      b0.setInt64(w, id);
      w += 8;
      if (w > _l.lengthInBytes) break;
    }
    return _l.sublist(0, w);
  }

  List<int> ListFromUint64binary(Uint8List data) {
    List<int> _l = [];
    if (data.isEmpty) return _l;
    var b = new ByteData.view(data.buffer);
    var w = 0;
    while (w < data.lengthInBytes) {
      _l.add(b.getInt64(w));
      w += 8;
    }
    return _l;
  }

  Future<bool> commitDeletesPreferences(List<int> l) async {
    //conv into binary
    if (db == null) return false;
    await _deletesCapBox.put('deletes', Uint64binaryList(l));
    print('[DB] prefs commit DONE');
    //_ubox.close();
    return true;
    //print(u.binary.sublist(64, 132));
  }

  Future<List<int>?> get readDeletesPreferences async {
    Uint8List? u = await _deletesCapBox.get('deletes');
    //_ubox.close();

    if (u == null) {
      return null;
    }
    return ListFromUint64binary(u);
  }

  Future<bool> commitMutesPreferences(List<String> l) async {
    //conv into binary
    if (db == null) return false;
    String s = '';
    l.forEach((element) {
      s = s + element + ':';
    });
    await _mutesCapBox.put('mutes', s);
    print('[DB] prefs commit DONE');
    //_ubox.close();
    return true;
    //print(u.binary.sublist(64, 132));
  }

  Future<List<String>?> get readMutesPreferences async {
    String? u = await _mutesCapBox.get('mutes');
    //_ubox.close();

    if (u == null) {
      return null;
    }
    print('[DB] read DONE');
    List<String> _l = [];
    var uu = u.split(':');
    _l.add(uu[0]); //sesid
    if (uu.length > 1) {
      _l.add(uu[1]);
    }
    return _l;
  }

  Future<bool> commitPreferences(String dartSesId, String author) async {
    //conv into binary
    if (db == null) return false;
    var p = dartSesId + ':' + author;
    await _prefsCapBox.put('prifs', p);
    print('[DB] prefs commit DONE');
    //_ubox.close();
    return true;
    //print(u.binary.sublist(64, 132));
  }

  Future<List<String>?> get readPreferences async {
    String? u = await _prefsCapBox.get('prifs');
    //_ubox.close();

    if (u == null) {
      return null;
    }
    print('[DB] read DONE');
    List<String> _l = [];
    var uu = u.split(':');
    _l.add(uu[0]); //sesid
    if (uu.length > 1) {
      _l.add(uu[1]);
    }
    return _l;
  }

  Future<bool> commitXX(Uint8List capsule, int xxHash) async {
    //conv into binary
    var k = xxHash.toString();

    _xxBox.put(k, capsule);
    print('[DB] commit DONE');
    //_ubox.close();
    return true;
    //print(u.binary.sublist(64, 132));
  }

  Uint8List? readXX(int xxInt) {
    var k = xxInt.toString();
    return _xxBox.get(k);
  }
}
